#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def orthonorm(y):
    (n,m)=np.shape(y)
    z=np.zeros((n,m))
    z[:,0]=y[:,0]/np.linalg.norm(y[:,0])
    for j in range(1,m):
        v=y[:,j]-np.dot(np.dot(z,z.T),y[:,j])
        z[:,j]=v/np.linalg.norm(v)
    return z




def qr(a):
    (n,m)=np.shape(a)
    a1=a.copy()
    r=min(n,m)
    h1=np.eye(n,n)
    for i in range(r-1):
        b1=a1.copy()
        x=a1[i:,i]
        x.shape=(n-i,1)
        q1,r1=np.linalg.qr(x)
        x[0]=x[0]+r1
        u=x/np.linalg.norm(x)
        h=np.eye(n,n)
        h[i:,i:]=np.eye(n-i,n-i)-2*np.dot(u,u.T)
        h1=np.dot(h,h1)
        a1=np.dot(h,b1)
    return h1.T,a1
    




               

a=np.random.rand(4,4)
a1=a.copy()
x=a1[:,0]
x.shape=(4,1)
q1,r1=np.linalg.qr(x)
print('r=',r1)
print(np.linalg.norm(x))
print('q=',q1)
x[0]=x[0]+r1
u=x/np.linalg.norm(x)
u.shape=(4,1)
h1=np.eye(4,4)-2*np.dot(u,u.T)
b=np.dot(h1,a)
print(b)
b1=b.copy()
x=b1[1:,1]
x.shape=(3,1)
q2,r2=np.linalg.qr(x)
x[0]=x[0]+r2
u=x/np.linalg.norm(x)
u.shape=(3,1)
h2=np.eye(4,4)
h2[1:,1:]=np.eye(3,3)-2*np.dot(u,u.T)
h=np.dot(h2,h1)
c=np.dot(h2,b)
print(c)
c1=c.copy()
x=c1[2:,2]
x.shape=(2,1)
q3,r3=np.linalg.qr(x)
x[0]=x[0]+r3
u=x/np.linalg.norm(x)
u.shape=(2,1)
h3=np.eye(4,4)
h3[2:,2:]=np.eye(2,2)-2*np.dot(u,u.T)
h=np.dot(h3,h)
d=np.dot(h3,c)
print(d)

print(np.dot(h.T,d))
verif=np.linalg.norm(np.dot(h.T,d)-a) #


a=np.random.rand(7,5) #np.random.rand(20,15)
z=orthonorm(a)
a1=a.copy()
q,r=np.linalg.qr(a)
print(np.linalg.norm(z-q[:,:5]))
print('z=',z)
print('r=',r)
print('q=',q)

print(np.linalg.norm(np.dot(z.T,z)-np.eye(5,5)))
print(np.linalg.norm(np.dot(q,r)-a1))
print(np.dot(q.T,a1))

a=np.random.rand(7,5)
q,r=np.linalg.qr(a)
print(np.linalg.norm(a-np.dot(q,r)))
z=orthonorm(a)
r1=np.dot(z.T,a)

print(np.linalg.norm(np.tril(r1-np.diag(np.diag(r1)))))


a=np.random.rand(4,4)
a1=a.copy()
x=a1[:,0]
x.shape=(4,1)
q1,r1=np.linalg.qr(x)
x[0]=x[0]+r1
u=x/np.linalg.norm(x)
h1=np.eye(4,4)-2*np.dot(u,u.T)
b=np.dot(h1,a)
print(b)
b1=b.copy()
x=b1[1:,1]
x.shape=(3,1)
q2,r2=np.linalg.qr(x)
x[0]=x[0]+r2
u=x/np.linalg.norm(x)
h2=np.eye(4,4)
h2[1:,1:]=np.eye(3,3)-2*np.dot(u,u.T)
c=np.dot(h2,b)
print(c)
c1=c.copy()
x=c1[2:,2]
x.shape=(2,1)
q3,r3=np.linalg.qr(x)
x[0]=x[0]+r3
u=x/np.linalg.norm(x)
h3=np.eye(4,4)
h3[2:,2:]=np.eye(2,2)-2*np.dot(u,u.T)
d=np.dot(h3,b)
print('d=',d)


a=np.array([[12,-51,4],[6,167,-68],[-4,24,-41]])
a1=a.copy()
x=a1[:,0]
x.shape=(3,1)
q1,r1=np.linalg.qr(x)
x[0]=x[0]+r1
u=x/np.linalg.norm(x)
h1=np.eye(3,3)-2*np.dot(u,u.T)
b=np.dot(h1,a)
print(b)
b1=b.copy()
x=b1[1:,1]
x.shape=(2,1)
q2,r2=np.linalg.qr(x)
x[0]=x[0]+r2
u=x/np.linalg.norm(x)
h2=np.eye(3,3)
h2[1:,1:]=np.eye(2,2)-2*np.dot(u,u.T)
c=np.dot(h2,b)
print(c)


q,r=qr(a)
#r=qr(a)
#q=np.dot(a,np.linalg.inv(r))
print(np.linalg.norm(np.dot(q.T,q)-np.eye(3)))
print(np.linalg.norm(np.dot(q,q.T)-np.eye(3)))

a=np.random.rand(20,15)
z=orthonorm(a)
#q,r=qr(a)
#print(np.linalg.norm(z-q[:,:15]))


a1=a.copy()
x=a1[:,0]
x.shape=(20,1)
q1,r1=np.linalg.qr(x)
x[0]=x[0]+r1
u=x/np.linalg.norm(x)
h1=np.eye(20,20)-2*np.dot(u,u.T)
b=np.dot(h1,a)
print(b[:,0])
b1=b.copy()
x=b1[1:,1]
x.shape=(19,1)
q2,r2=np.linalg.qr(x)
x[0]=x[0]+r2
u=x/np.linalg.norm(x)
h2=np.eye(20,20)
h2[1:,1:]=np.eye(19,19)-2*np.dot(u,u.T)
c=np.dot(h2,b)
print(c[:,1])
c1=c.copy()
x=c1[2:,2]
x.shape=(18,1)
q3,r3=np.linalg.qr(x)
x[0]=x[0]+r3
u=x/np.linalg.norm(x)
h3=np.eye(20,20)
h3[2:,2:]=np.eye(18,18)-2*np.dot(u,u.T)
d=np.dot(h3,c)

a=np.random.rand(20,15)
z=orthonorm(a)
q,r=qr(a)
print(np.linalg.norm(z-q[:,:15]))
print(np.linalg.norm(np.dot(q,r)-a))
print(np.linalg.norm(np.dot(q,q.T)-np.eye(20)))
print(np.linalg.norm(np.dot(q.T,q)-np.eye(20)))

q,r=np.linalg.qr(a)
print(np.linalg.norm(z-q[:,:15]))
print('q=',np.shape(q))
print('r=',np.shape(r))
np.dot(q,r)
print(np.linalg.norm(np.dot(q,r)-a))

print(np.linalg.norm(np.dot(q.T,q)-np.eye(15)))