#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def orthonorm(y):
    (n,m)=np.shape(y)
    z=np.zeros((n,m))
    z[:,0]=y[:,0]/np.linalg.norm(y[:,0])
    for j in range(1,m):
        v=y[:,j]-np.dot(np.dot(z,z.T),y[:,j])
        z[:,j]=v/np.linalg.norm(v)
    return z




def qr(a):
    (n,m)=np.shape(a)
    a1=a.copy()
    r=min(n,m)
    h1=np.eye(n,n)
    for i in range(r-1):
        b1=a1.copy()
        x=a1[i:,i]
        x.shape=(n-i,1)
        q1,r1=np.linalg.qr(x)
        x[0]=x[0]+r1
        u=x/np.linalg.norm(x)
        h=np.eye(n,n)
        h[i:,i:]=np.eye(n-i,n-i)-2*np.dot(u,u.T)
        h1=np.dot(h,h1)
        a1=np.dot(h,b1)
    return h1.T,a1
    
    
def puiss_mat(a,m,eps):
    (l,n)=np.shape(a)
    x=np.random.rand(n,m)
    crit=1
    itmax=200
    i=0
    while (crit>eps) and (i<itmax):
        y=np.dot(a,x)
        nu=np.dot(x.T,y)
        x=orthonorm(y)
        crit=np.linalg.norm(np.triu(nu)-np.tril(nu))
        i=i+1
    return np.diag(nu),i
    
def puiss_mat1(a,m,eps):
    (l,n)=np.shape(a)
    x=np.random.rand(n,m)
    crit=1
    itmax=200
    i=0
    tabcrit=np.zeros(itmax)
    tabit=np.zeros(itmax)
    while (crit>eps) and (i<itmax):
        y=np.dot(a,x)
        nu=np.dot(x.T,y)
        x=orthonorm(y)
        #crit=np.linalg.norm(np.triu(nu)-np.tril(nu))
        v=np.diag(nu)
        crit=np.linalg.norm(v-np.diag(np.diag(100*0.9**(np.arange(1,m+1)))))
        tabit[i]=i+1
        tabcrit[i]=crit
        i=i+1
    return v,tabcrit[:i],tabit[:i]
    
def qr_valp(a,eps):
    a0=a.copy()
    crit=1
    itmax=200
    i=0
    while (crit>eps) and (i<itmax):
        q,r=qr(a0)
        a0=np.dot(r,q)
        crit=np.linalg.norm(a0-np.triu(a0))
        i=i+1
    return np.diag(a0),i

eps=1e-3

n=40

J=np.random.rand(n,n)
U=orthonorm(J)
print(np.linalg.norm(np.dot(U,U.T)-np.eye(n,n))+np.linalg.norm(np.dot(U.T,U)-np.eye(n,n)))

A=np.dot(np.dot(U,np.diag(100*0.9**(np.arange(1,n+1)))),U.T)

D,i=qr_valp(A,eps)
print(np.linalg.norm(D-np.diag(np.diag(100*0.9**(np.arange(1,n+1))))),'obtenu en',i,'pas')




        